# Get transaction banking account balance Get balances associated with a specific account. These balances include available, credit, debit balance, and so on. # OpenAPI definition ```json { "openapi": "3.0.0", "info": { "title": "Banking - Transaction banking", "version": "0.9.0", "description": "Transaction banking API", "contact": { "name": "API Support", "url": "https://developers.pismo.io/support/" }, "license": { "name": "Copyright Pismo" } }, "servers": [ { "url": "https://sandbox.pismolabs.io", "description": "Sandbox API server for testing" } ], "security": [ { "BearerAuth": [] } ], "tags": [ { "name": "Bank statements", "description": "Bank statements endpoints" } ], "components": { "parameters": { "ExternalAccountIdPath": { "name": "externalAccountId", "in": "path", "description": "External account ID", "schema": { "type": "string", "minLength": 1, "maxLength": 60 }, "example": "12345678901", "required": true } }, "schemas": { "AccountBalanceMainAttributes": { "type": "object", "required": [ "future_dated_credits_balance", "future_dated_debits_balance" ], "properties": { "future_dated_credits_balance": { "$ref": "#/components/schemas/FutureDatedCreditsBalance" }, "future_dated_debits_balance": { "$ref": "#/components/schemas/FutureDatedDebitsBalance" }, "ledger_balance": { "$ref": "#/components/schemas/LedgerBalance" }, "book_balance": { "$ref": "#/components/schemas/BookBalance" }, "available_balance": { "$ref": "#/components/schemas/AvailableBalance" }, "credit_balance": { "$ref": "#/components/schemas/CreditBalance" }, "debit_balance": { "$ref": "#/components/schemas/DebitBalance" }, "uncleared_funds": { "$ref": "#/components/schemas/UnclearedFunds" }, "uncleared_checks_balance": { "$ref": "#/components/schemas/UnclearedChecksBalance" }, "restricted_funds": { "$ref": "#/components/schemas/RestrictedFundsBalance" }, "earmarked_balance": { "$ref": "#/components/schemas/EarmarkBalance" }, "overdraft_limit": { "$ref": "#/components/schemas/OverdraftLimit" }, "value_dated_balance": { "$ref": "#/components/schemas/ValueDatedBalance" }, "held_funds": { "$ref": "#/components/schemas/HeldFunds" }, "held_checks_balance": { "$ref": "#/components/schemas/HeldChecksBalance" }, "remunerative_interest_accrued": { "$ref": "#/components/schemas/RemunerativeInterestAccrued" } } }, "AccountBalanceResponse": { "allOf": [ { "type": "object", "required": [ "future_dated_credits_balance", "future_dated_debits_balance" ], "properties": { "future_dated_credits_balance": { "$ref": "#/components/schemas/FutureDatedCreditsBalance" }, "future_dated_debits_balance": { "$ref": "#/components/schemas/FutureDatedDebitsBalance" }, "account_id": { "$ref": "#/components/schemas/AccountID" }, "external_account_id": { "$ref": "#/components/schemas/ExternalAccountID" }, "program_id": { "$ref": "#/components/schemas/ProgramID3" }, "currency_numeric_code": { "$ref": "#/components/schemas/AccountNumericCurrencyCode" }, "currency_alphabetic_code": { "$ref": "#/components/schemas/AccountAlphabeticCurrencyCode" } } }, { "$ref": "#/components/schemas/AccountBalanceMainAttributes" } ] }, "AccountID": { "type": "integer", "format": "int64", "description": "Account ID", "example": 1234 }, "AvailableBalance": { "type": "number", "format": "float", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "description": "Available balance.
\nAvailable balance is calculated as `credit_balance` - `debit_balance` + `overdraft_limit`.\n`minimum: -9223372036854775807`\n`maximum: 9223372036854775807`\n", "example": 123.45 }, "BookBalance": { "type": "number", "format": "float", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "description": "Book balance.
\nBook balance is calculated as `credit_balance` - `debit_balance` + `earmarked_balance`.\n`minimum: -9223372036854775807`\n`maximum: 9223372036854775807`\n", "example": 146.9 }, "CreditBalance": { "type": "number", "description": "Credit balance", "format": "float", "example": 123.45 }, "AccountNumericCurrencyCode": { "type": "string", "minLength": 3, "maxLength": 3, "description": "Account numeric currency code in ISO 4217 format. If not specified, it's inherited from the program.\n", "example": "840" }, "AccountAlphabeticCurrencyCode": { "type": "string", "minLength": 3, "maxLength": 3, "description": "Account alphabetic currency code in ISO 4217 format. If not specified, it's inherited from the program.\n", "example": "USD" }, "DebitBalance": { "type": "number", "description": "Debit balance", "format": "float", "example": 123.45 }, "EarmarkBalance": { "type": "number", "description": "Earmark balance. Initially equal to the earmarked amount and decreases as the reserved funds are used up or decreased in a decrease operation. It can also increase if an increase operation is performed.
\n`minimum: 0`\n`maximum: 18446744073709551617`\n", "minimum": 0, "maximum": 18446744073709552000, "example": 123.45 }, "ErrorCode": { "description": "Error code\n`minLength: 1`\n`maxLength: 12`\n", "type": "string", "minLength": 1, "maxLength": 12, "example": "WPMT0017" }, "ErrorMessage": { "description": "Error message\n`minLength: 1`\n`maxLength: 1000`\n", "type": "string", "minLength": 1, "maxLength": 1000, "example": "Invalid JSON payload received: Error unmarshalling request" }, "ErrorResponse": { "type": "object", "properties": { "code": { "$ref": "#/components/schemas/ErrorCode" }, "message": { "$ref": "#/components/schemas/ErrorMessage" } } }, "ExternalAccountID": { "maxLength": 60, "type": "string", "pattern": "^[a-zA-Z0-9-]+$", "description": "Custom account ID. Used as the key for all operations (manage accounts, transactions, etc.) on the corporate layer.\n\nThis field is:\n- Unique within the Organization\n- Immutable: The field cannot be updated.\n- Not recyclable: You can't reuse an external account ID, even if the account that was using it has been canceled.\n", "example": "b993ba96-b3e8-4ef7-9cf7-7eee5ddafdab" }, "FutureDatedCreditsBalance": { "description": "Represents the account balance scheduled to be settled on a future date, after the original posting date. The account's `book_balance` is credited when the settlement occurs.
\nThe `future_dated_credits_balance` increases when future-dated credits are posted using the [Post payment](https://developers.pismo.io/pismo-docs/reference/corporate-v2-post-payments) endpoint, and decreases when those payments are settled or canceled. This balance is always a positive value.
\n`minimum`: `-9223372036854775807`\n`maximum`: `9223372036854775807`\n", "type": "number", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "example": 70 }, "FutureDatedDebitsBalance": { "description": "Represents the account balance scheduled to be settled on a future date, after the initial posting date. The account’s `book_balance` is debited when the settlement occurs.
\nThe `future_dated_debits_balance` increases when future-dated debits are posted using the [Post payment](https://developers.pismo.io/pismo-docs/reference/corporate-v2-post-payments) endpoint, and decreases when these payments are settled or canceled. This balance is always a positive value.
\n`minimum`: `-9223372036854775807`\n`maximum`: `9223372036854775807`\n", "type": "number", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "example": 70 }, "LedgerBalance": { "type": "number", "format": "float", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "description": "Ledger balance.
\nLedger balance is calculated as `book_balance` + `uncleared_funds`.\n`minimum: -9223372036854775807`\n`maximum: 9223372036854775807`\n", "example": 270.35 }, "OverdraftLimit": { "type": "number", "format": "float", "minimum": 0, "maximum": 18446744073709552000, "description": "Account overdraft limit
\n`minimum: 0`\n`maximum: 18446744073709551617`\n", "example": 123.45 }, "ProgramID3": { "type": "integer", "format": "int64", "description": "Program ID. This is a client-provided ID.", "example": 2222 }, "RestrictedFundsBalance": { "type": "number", "format": "float", "description": "The portion of an account balance held under regulatory or operational restrictions and not available for transactions.\n`minimum`: 0\n`maximum`: 9223372036854775807\n", "minimum": 0, "maximum": 9223372036854776000 }, "HeldFunds": { "type": "number", "format": "float", "description": "Funds that are temporarily restricted due to regulatory or operational requirements, unavailable for transactions, and representing the total amount of earmarked or otherwise restricted balances.\n`minimum`: 0\n`maximum`: 9223372036854775807\n", "minimum": 0, "maximum": 9223372036854776000 }, "HeldChecksBalance": { "type": "number", "format": "float", "description": "The balance from checks that the bank considers available but holds to earn interest. It increases when check holds are applied and decreases when those holds are released or canceled.\n`minimum`: 0\n`maximum`: 9223372036854775807\n", "minimum": 0, "maximum": 9223372036854776000 }, "RemunerativeInterestAccrued": { "type": "number", "format": "float", "description": "This balance reflects the total interest pending capitalization. It increases as interest accrues and decreases when the accrued interest is added to the principal balance.\n`minimum`: 0\n`maximum`: 9223372036854775807\n", "minimum": 0, "maximum": 9223372036854776000 }, "UnclearedChecksBalance": { "type": "number", "format": "float", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "description": "The total value of checks that have been posted to the account but have not yet cleared.\n`minimum: -9223372036854775807`\n`maximum: 9223372036854775807`\n" }, "UnclearedFunds": { "type": "number", "format": "float", "minimum": -9223372036854776000, "maximum": 9223372036854776000, "description": "Uncleared funds amount
\n`minimum: -9223372036854775807`\n`maximum: 9223372036854775807`\n", "example": 123.45 }, "ValueDatedBalance": { "type": "number", "description": "The value dated balance results from recalculating credit or debit balance based on the back value date. Defaults to the book balance.
\nThe value dated balance is included in the following events:\n- [Account balance changed](https://developers.pismo.io/events/docs/account-balances-balance-change-1)\n- [Account balance history generated](https://developers.pismo.io/events/docs/account-balances-balance-history-1)\n", "format": "float", "example": 123.45 } }, "responses": { "500InternalServer2": { "description": "Internal Server Error", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorResponse" }, "examples": { "Generic internal error": { "value": { "code": "CMN9999", "message": "Internal error" } }, "Account balance unknown": { "value": { "code": "EABL0001", "message": "Account balance unknown" } } } } } } }, "securitySchemes": { "BearerAuth": { "type": "http", "scheme": "bearer", "bearerFormat": "JWT" } } }, "paths": { "/bank-statements/v1/account-balances/{externalAccountId}": { "get": { "summary": "Get transaction banking account balance", "description": "Get balances associated with a specific account. These balances include available, credit, debit balance, and so on.\n", "operationId": "get-account-balances", "tags": [ "Bank statements" ], "parameters": [ { "$ref": "#/components/parameters/ExternalAccountIdPath" } ], "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/AccountBalanceResponse" }, "examples": { "Example account balance": { "value": { "future_dated_credits_balance": 0, "future_dated_debits_balance": 0, "account_id": 1234, "external_account_id": "b993ba96-b3e8-4ef7-9cf7-7eee5ddafdab", "currency_numeric_code": "840", "currency_alphabetic_code": "USD", "program_id": 8674, "ledger_balance": 110, "book_balance": 70, "available_balance": 50, "credit_balance": 50, "debit_balance": 0, "uncleared_funds": 40, "uncleared_checks_balance": 0, "earmarked_balance": 20, "overdraft_limit": 0, "value_dated_balance": 70, "restricted_funds": 0, "remunerative_interest_accrued": 1.23 } } } } } }, "400": { "description": "Bad Request", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorResponse" }, "examples": { "external_account_id validation error": { "value": { "code": "CMN0002", "message": "external_account_id must be a maximum of 60 characters in length" } }, "invalid header account": { "value": { "code": "WABL0003", "message": "Invalid header account" } } } } } }, "401": { "description": "Unauthorized", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorResponse" }, "examples": { "Account not authorized": { "value": { "code": "WABL0002", "message": "Account not authorized" } } } } } }, "403": { "description": "Forbidden", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorResponse" }, "examples": { "Forbidden request": { "value": { "message": "access denied" } } } } } }, "404": { "description": "Not Found", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorResponse" }, "examples": { "Transaction not found": { "value": { "code": "WABL0001", "message": "Account balance not found" } } } } } }, "500": { "$ref": "#/components/responses/500InternalServer2" } } } } } } ```